bl_info = {
    "name": 'Material selector for Farming Simulator 19',
    "author": 'Hiel Jorn',
    "blender": ( 2, 7, 0 ),
    "version": ( 1, 2, 0 ),
    'category': 'All',
    "description": "Udim tool for Farming Simulator 19",
	"warning": "Use wisely",
	"wiki_url": "",
    "tracker_url": "",
    "category": "Game Engine"
}

import bpy
from bpy.props import *
import bmesh, math, os


def initSceneProperties(scn):
    print("Udim menu for Farming simulator - Loaded")
    return
    initSceneProperties(bpy.context.scene)

class addColorMaterialOne(bpy.types.Panel):

    button0 = "Color - 0"
    button1 = "Color - 1"
    button2 = "Color - 2"
    button3 = "Color - 3"
    button4 = "Color - 4"
    button5 = "Color - 5"
    button6 = "Color - 6"
    button7 = "Color - 7"


    button10 = "Painted Metal"
    button11 = "Painted Plastic"
    button12 = "Chrome"
    button13 = "Copper"
    button14 = "Galvanized Metal"
    button15 = "Rubber"
    button16 = "Painted Old Metal"
    button17 = "Fabric"

    button20 = "Silver scratched"
    button21 = "Silver Bumpy"
    button22 = "Fabric 1"
    button23 = "Fabric 2"
    button24 = "Leather 1"
    button25 = "Leather 2"
    button26 = "Wood"
    button27 = "Dirt"

    button30 = "Painted metal Black"
    button31 = "Painted Plastic White"
    button32 = "Silver Rough"
    button33 = "Brass Scratched"
    button34 = "Reflector White"
    button35 = "Reflector Red"
    button36 = "Reflector Yellow"
    button37 = "Reflector Daylight"

    button40 = "Gear Shift  Plastic"
    button41 = "Leather Grey"
    button42 = "Perforated Syntetic Plastic"
    button43 = "Glass - Clear"
    button44 = "Glass - Square"
    button45 = "Glass - Line"
    button46= "Palladium"
    button47 = "Bronze"


    button60 = "Graphite"
    button61 = "Half metal + noise"
    button62 = "gray shiny Plastic"
    button63 = "Gold"
    button64 = "Rough painted Metal"
    button65 = "Perforated Syntethic "
    button66 = "Fell"

    button50 = "Up - Left"
    button51 = "Left"
    button52 = "Down - Left"
    button53 = "Up"
    button54 = "Down"
    button55 = "Up - Right"
    button56 = "Right"
    button57 = "Down - Right"

    bl_idname = "panel.panelFarming"
    bl_label = "Material Selector"
    bl_space_type = "IMAGE_EDITOR"
    bl_region_type = "TOOLS"
    bl_category = "Material Selector"

    def draw(self, context):

        layout = self.layout
		

        layout.label("Selectable Colors")
        row = layout.row()

        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button0).location = " 0 / -1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button3).location = " 3 / -1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button6).location = " 6 / -1"
        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button1).location = " 1 / -1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button4).location = " 4 / -1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button7).location = " 7 / -1"
        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button2).location = " 2 / -1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button5).location = " 5 / -1"
        layout.row()
        layout.label("Predefined")
        layout.row()

        row = layout.row()
        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button10).location = " 0 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button11).location = " 1 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button12).location = " 2 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button13).location = " 3 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button14).location = " 4 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button15).location = " 5 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button16).location = " 6 / 0"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button17).location = " 7 / 0"

        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button20).location = " 0 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button21).location = " 1 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button22).location = " 2 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button23).location = " 3 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button24).location = " 4 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button25).location = " 5 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button26).location = " 6 / 1"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button27).location = " 7 / 1"
        col.row()
        col.row()

        layout.row()

        row = layout.row()
        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button30).location = " 0 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button31).location = " 1 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button32).location = " 2 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button33).location = " 3 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button34).location = " 4 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button35).location = " 5 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button36).location = " 6 / 2"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button37).location = " 7 / 2"

        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button40).location = " 0 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button41).location = " 1 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button42).location = " 2 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button43).location = " 3 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button44).location = " 4 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button45).location = " 5 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button46).location = " 6 / 3"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button47).location = " 7 / 3"
        layout.row()
        layout.row()

        row = layout.row()
        split = row.split(percentage=0.5)
        col = split.column()
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button60).location = " 0 / 4"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button61).location = " 1 / 4"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button62).location = " 2 / 4"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button63).location = " 3 / 4"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button64).location = " 4 / 4"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button65).location = " 5 / 4"
        col.operator("mesh.move_somewhere", icon='ACTION', text=self.button66).location = " 6 / 4"


        layout.label("Move by grid")
        row = layout.row()

        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_up_left", icon='ACTION', text=self.button50)
        col.operator("mesh.move_left", icon='ACTION', text=self.button51)
        col.operator("mesh.move_down_left", icon='ACTION', text=self.button52)
        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_up", icon='ACTION', text=self.button53)
        col.operator("mesh.move_center", text="", emboss=False)
        col.operator("mesh.move_down", icon='ACTION', text=self.button54)
        split = row.split(percentage=1)
        col = split.column()
        col.operator("mesh.move_up_right", icon='ACTION', text=self.button55)
        col.operator("mesh.move_right", icon='ACTION', text=self.button56)
        col.operator("mesh.move_down_right", icon='ACTION', text=self.button57)


class MoveDown(bpy.types.Operator):
    bl_idname = 'mesh.move_down'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(0.0, -1.0, 0.0))

        return {"FINISHED"}


class MoveUp(bpy.types.Operator):
    bl_idname = 'mesh.move_up'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(0.0, 1.0, 0.0))
        return {"FINISHED"}


class MoveLeft(bpy.types.Operator):
    bl_idname = 'mesh.move_left'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(-1.0, 0.0, 0.0))
        return {"FINISHED"}


class MoveLeftUp(bpy.types.Operator):
    bl_idname = 'mesh.move_up_left'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(-1.0, 1.0, 0.0))
        return {"FINISHED"}


class MoveLeftDown(bpy.types.Operator):
    bl_idname = 'mesh.move_down_left'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(-1.0, -1.0, 0.0))
        return {"FINISHED"}


class MoveRight(bpy.types.Operator):
    bl_idname = 'mesh.move_right'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(1.0, 0.0, 0.0))
        return {"FINISHED"}


class MoveUpRight(bpy.types.Operator):
    bl_idname = 'mesh.move_up_right'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(1.0, 1.0, 0.0))
        return {"FINISHED"}


class MoveDownRight(bpy.types.Operator):
    bl_idname = 'mesh.move_down_right'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(1.0, -1.0, 0.0))
        return {"FINISHED"}


class MoveCenter(bpy.types.Operator):
    bl_idname = 'mesh.move_center'
    bl_label = 'Farming color 0'

    def invoke(self, context, event):
        bpy.context.area.type = 'IMAGE_EDITOR'
        bpy.ops.transform.translate(value=(0.0, 0.0, 0.0))
        return {"FINISHED"}


class moveThis(bpy.types.Operator):

    bl_idname = 'mesh.move_somewhere'
    bl_label = 'Farming Custom Material 1'
    location = bpy.props.StringProperty()

    def execute(self, context):
        x2_location,y2_location=self.location.split(('/'))
        mover = Mover
        mover.moveMe(self, context, float(x2_location), float(y2_location))
        return {"FINISHED"}



class Mover:

    def moveMe (self, context, x_location,y_location):
        bpy.context.area.type = 'IMAGE_EDITOR'
        target = [x_location, y_location]
        current = [0.0, 0.0]
        move = [0.0, 0.0]
        #09/01
        bpy.ops.object.mode_set(mode='EDIT')
        bpy.ops.uv.select_all(action='SELECT')

        bpy.ops.object.mode_set(mode='OBJECT')

        uvs = context.object.data.uv_layers.active.data
        
        for uv in uvs:
            if uv.select:
                current[0] += uv.uv[0]
                current[1] += uv.uv[1]
                move[0] = target[0] - math.floor(current[0])
                move[1] = target[1] - math.floor(current[1])
                break

        bpy.ops.object.mode_set(mode='EDIT')
        
        
        
        bpy.ops.transform.translate(value=(move[0], move[1], 0.0))
        #09/01
        bpy.ops.uv.select_all(action='DESELECT')
        return {"FINISHED"}


def register():
    bpy.utils.register_module(__name__)


def unregister():
    bpy.utils.unregister_module(__name__)
